------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2011 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Child_Events;
with Qt4.Events;
with Qt4.Timer_Events;
with Qt_Ada.Internals.Events;
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Mime_Datas.Directors is

   function qt_metacall_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Kind : Qt4.Meta_Objects.Call;
     Id   : Qt4.Q_Integer;
     Args : Qt4.Address_Pointer)
       return Qt4.Q_Integer;
   pragma Import (C, qt_metacall_wrapper,
                  "__Qt4Ada_QMimeData_qt_metacall_wrapper");

   function qt_metacast_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Class : Interfaces.C.char_array)
       return System.Address;
   pragma Import (C, qt_metacast_wrapper,
                  "__Qt4Ada_QMimeData_qt_metacast_wrapper");

   function formats_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
       return not null access Qt4.String_Lists.Internals.QStringList;
   pragma Export (C, formats_0_dispatch,
                     "__Qt4Ada_QMimeData_formats_0_dispatch");
   pragma Warnings (Off, formats_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure formats_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.String_Lists.Internals.QStringList);
   pragma Import (C, formats_0_wrapper,
                     "__Qt4Ada_QMimeData_formats_0_wrapper");

   function hasFormat_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Mime_Type : not null access Qt4.Strings.Internals.QString)
       return Qt4.bool;
   pragma Export (C, hasFormat_0_dispatch,
                     "__Qt4Ada_QMimeData_hasFormat_0_dispatch");
   pragma Warnings (Off, hasFormat_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   function hasFormat_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mime_Type : not null access constant Qt4.Strings.Internals.QString)
       return Qt4.bool;
   pragma Import (C, hasFormat_0_wrapper,
                     "__Qt4Ada_QMimeData_hasFormat_0_wrapper");

   procedure childEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, childEvent_0_wrapper,
                     "__Qt4Ada_QMimeData_childEvent_0_wrapper");

   procedure customEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, customEvent_0_wrapper,
                     "__Qt4Ada_QMimeData_customEvent_0_wrapper");

   procedure timerEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, timerEvent_0_wrapper,
                     "__Qt4Ada_QMimeData_timerEvent_0_wrapper");

   function sender_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, sender_0_wrapper,
                     "__Qt4Ada_QMimeData_sender_0_wrapper");

   ------------------
   -- Constructors --
   ------------------

   package body Constructors is

      function new_QMimeDataDirector
       (Object : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
          return not null Qt_Ada.Internals.Objects.QObject_Access;
      pragma Import
       (C, new_QMimeDataDirector, "__Qt4Ada_new_QMimeDataDirector");
      pragma Warnings (Off, new_QMimeDataDirector);

      ----------------
      -- Initialize --
      ----------------

      procedure Initialize
       (Self : not null access Q_Mime_Data_Director'Class)
      is
         Director : constant not null Qt_Ada.Internals.Objects.QObject_Access
           := new_QMimeDataDirector
               (Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self));

      begin
         Qt_Ada.Internals.Objects.Initialize (Self, Director);
      end Initialize;

   end Constructors;

   pragma Style_Checks ("N");

   ------------------------
   -- formats_0_dispatch --
   ------------------------

   function formats_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
       return not null access Qt4.String_Lists.Internals.QStringList
   is
   begin
      return
        Qt4.String_Lists.Thin.copy_QStringList
         (Qt4.String_Lists.Internals.QStringList_View
           (Q_Mime_Data_Director'Class (Self.all).Formats));
   end formats_0_dispatch;

   -------------
   -- Formats --
   -------------

   overriding
   function Formats
    (Self : not null access constant Q_Mime_Data_Director)
       return Qt4.String_Lists.Q_String_List
   is
      Returns : Qt4.String_Lists.Q_String_List;

   begin
      formats_0_wrapper
       (Q_Mime_Data_Director'Class (Self.all).QObject_View,
        Qt4.String_Lists.Internals.QStringList_View (Returns));

      return Returns;
   end Formats;

   --------------------------
   -- hasFormat_0_dispatch --
   --------------------------

   function hasFormat_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Mime_Type : not null access Qt4.Strings.Internals.QString)
       return Qt4.bool
   is
   begin
      return
        Qt4.To_bool
         (Q_Mime_Data_Director'Class (Self.all).Has_Format
           (Qt4.Strings.Internals.Create_Wrapper (Qt4.Strings.Internals.QString_Access (Mime_Type))));
   end hasFormat_0_dispatch;

   ----------------
   -- Has_Format --
   ----------------

   overriding
   function Has_Format
    (Self : not null access constant Q_Mime_Data_Director;
     Mime_Type : Qt4.Strings.Q_String)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasFormat_0_wrapper
           (Q_Mime_Data_Director'Class (Self.all).QObject_View,
            Qt4.Strings.Internals.QString_View (Mime_Type)));
   end Has_Format;

   -----------------
   -- Child_Event --
   -----------------

   overriding
   procedure Child_Event
    (Self : not null access Q_Mime_Data_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class)
   is
   begin
      childEvent_0_wrapper
       (Q_Mime_Data_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Child_Event;

   ------------------
   -- Custom_Event --
   ------------------

   overriding
   procedure Custom_Event
    (Self : not null access Q_Mime_Data_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      customEvent_0_wrapper
       (Q_Mime_Data_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Custom_Event;

   -----------------
   -- Timer_Event --
   -----------------

   overriding
   procedure Timer_Event
    (Self : not null access Q_Mime_Data_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class)
   is
   begin
      timerEvent_0_wrapper
       (Q_Mime_Data_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Timer_Event;

   ------------
   -- Sender --
   ------------

   overriding
   function Sender
    (Self : not null access constant Q_Mime_Data_Director)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object
         (sender_0_wrapper
           (Q_Mime_Data_Director'Class (Self.all).QObject_View));
   end Sender;

begin
   Qt_Ada.Internals.Object_Registry.Register_Director
    ("QMimeData", qt_metacast_wrapper'Access, qt_metacall_wrapper'Access);

end Qt4.Mime_Datas.Directors;
